<template>
	<f7-page 
        name="info" 
        @page:beforein="onPageBeforeIn"
        @page:beforeout="onPageBeforeOut"
        ptr 
        @ptr:refresh="onPageRefresh"
        infinite
        :infinite-distance="50"
        :infinite-preloader="showPreloader"
        @infinite="loadMore">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large title-large="Info RingSatu">
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title class="show-small-title">{{ currentCategory }}</f7-nav-title>
            <f7-nav-right>
                <f7-link href="/info/create/" icon-f7="add" color="smoothgray" icon-only></f7-link>
            </f7-nav-right>
		</f7-navbar>

		<!-- Page content-->
        <f7-block>
			<f7-toolbar tabbar scrollable position="top" no-shadow no-hairlines class="no-background" style="top:0;">
                <f7-link @click="handleInfoCategory('semua')" :class="`gradient-box${slugify(currentCategory) == 'semua' ? ' tab-link-active' : ''}`">
					<span class="">Semua</span>									
				</f7-link>
                <f7-link @click="handleInfoCategory('info-saya')" :class="`gradient-box${slugify(currentCategory) == 'info-saya' ? ' tab-link-active' : ''}`">
					<span class="">Info Saya</span>									
				</f7-link>
			</f7-toolbar>
		</f7-block>
        <f7-list media-list no-hairlines v-if="!infoLoading && pageInfos.length > 0">
            <f7-list-item
                v-for="(item, index) in pageInfos"
                :key="index"
                link                
                :after="hoursAgo(item.created)"
                :title="item.user.profile.fullname"
                :subtitle="item.title"
                :text="truncate(stripHTML(item.body))"
                :data-info="JSON.stringify(item)"
            >
                <img v-if="item.user.profile.media != null" :src="item.user.profile.media.url.small" width="48" height="48" class="img-circle" slot="media"/>
                <div v-else :data-initial-medium="item.user.profile.initial" slot="media"></div>
            </f7-list-item>            
        </f7-list>
        <f7-block v-else-if="!infoLoading" style="height: calc(100% - 100px)">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="notifications_off" style="font-size:100px;color:#eee;"></f7-icon>
						<span class="display-block">It's a little quiet here</span>
					</span>
				</span>
			</span>
		</f7-block>
        <f7-list media-list no-hairlines v-if="infoLoading">
            <f7-list-item
                v-for="n in 4"
                :key="n"
                class="skeleton-text skeleton-effect-blink"
                title="Full Name"
                subtitle="Lorem ipsum dolor sit amet"
                after="31 Juli 2019"
                text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi lobortis et massa ac interdum. Cras consequat felis at consequat hendrerit. Aliquam vestibulum vitae lorem ac iaculis. Praesent nec pharetra massa, at blandit lectus. Sed tincidunt, lectus eu convallis elementum, nibh nisi aliquet urna, nec imperdiet felis sapien at enim."
            >
                <f7-skeleton-block style="width: 48px; height: 48px; border-radius: 50%" slot="media"></f7-skeleton-block>
            </f7-list-item>
        </f7-list>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { hoursAgo, dateFormat, truncate, stripHTML, slugify, parseError } from '../js/utils';
import { setTimeout } from 'timers';
export default {
    name: 'Info',
    data(){
        return {
            infoLoading: true,
            allowInfinite: true,
            showPreloader: true,
            currentCategory: 'Semua'
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
		...mapGetters('info', [
			'pageInfos',
			'pagination'
        ]),
        currentLocation: function(){
			const self = this;

			let currentLocation = localStorage.getItem('currentLocation') ? JSON.parse(localStorage.getItem('currentLocation')) : null;
			return currentLocation;
		}
    },
    mounted(){
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;

        $$('div[data-name="info"]').on('click', '.media-list li', function(){
            let info = JSON.parse($$(this).data('info'));
            
            if(info.user.id == self.user.id && self.currentCategory == 'Info Saya'){
                self.showActionSheet(info);
            }else{
                self.$f7router.navigate('/info/view/'+info.id+'/', {
                    ignoreCache: true
                });
            }
        });
    },
    methods: {
        hoursAgo,
        dateFormat,
        truncate,
        stripHTML,
        slugify,
        getInfos(page, loadmore){
			const self = this;
            const app = self.$f7;

            let author = null;

            if(self.currentCategory == 'Info Saya'){
                author = self.user.id;
            }
            
			self.$store.dispatch('info/getInfos', {
				page: page,
                perpage: 25,
                section: 'page',
                loadmore: loadmore,
                user: author,
                latitude: self.currentLocation != null ? self.currentLocation.latitude : null,
                longitude: self.currentLocation != null ? self.currentLocation.longitude : null,
                only: 'id,title,slug,body,created,updated,medias.id,medias.mimetype,medias.url,medias.filename,medias.original_filename,user.id,user.profile,user.profile.fullname,user.profile.initial,user.profile.media'
			}).then(() => {                
                setTimeout(() => {
                    self.infoLoading = false;
                    self.showPreloader = self.pagination.has_next;
                }, 100);
            });
		},
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;

            if(self.currentLocation != null){
				self.getInfos(1, false);
            }else{
                self.infoLoading = false;
                self.showPreloader = false;
            }
        },    
        onPageBeforeOut(page){
            const self = this;

            if(page.detail.name == 'info'){
                self.currentCategory = 'Semua';
                self.$store.dispatch('info/resetInfos', {
                    section: 'page'
                });
            }
        },    
        onPageRefresh(e, done){
            const self = this;
            
            self.$store.dispatch('info/resetInfos', {
                section: 'page'
            }).then(()=>{
                if(self.currentLocation != null){
                    self.infoLoading = true;
                    self.getInfos(1, false);
                }else{
                    self.infoLoading = false;
                    self.showPreloader = false;
                }
                done();
            });
        },
        showActionSheet(info){
            const self = this;
            const app = self.$f7;

            let buttons = [{
                text: info.title,
                label: true
            }, {
                text: 'Lihat',
                close: true,
                onClick: function(actions, e){
                    self.$f7router.navigate('/info/view/'+info.id+'/', {
                        ignoreCache: true
                    });
                }
            }, {
                text: 'Ubah',
                close: true,
                onClick: function(actions, e){
                    self.$f7router.navigate('/info/edit/'+info.id+'/', {
                        ignoreCache: true
                    });
                }
            }, {
                text: 'Hapus',
                close: true,
                onClick: function(actions, e){
                    app.dialog.confirm('Anda yakin ingin menghapus informasi ini?', function(){
                        app.preloader.show('green');
                        self.$store.dispatch('info/deleteInfo', {
                            id: info.id,
                            only: 'id,title,slug,body,created,updated,medias.mimetype,medias.url,medias.filename,medias.original_filename,user.id,user.profile,user.profile.fullname,user.profile.initial,user.profile.media'
                        }).then((response)=>{
                            app.preloader.hide();

                            if('errors' in response){
                                let error = parseError(response.errors);
                                app.dialog.alert(error.messages, 'RingSatu');
                                return false;
                            }else{
                                self.currentCategory = 'Info Saya';
                                self.$store.dispatch('info/resetInfos', {
                                    section: 'page'
                                }).then(()=>{
                                    self.infoLoading = true;
                                    self.getInfos(1, false);
                                });
                            }                            
                        });
                    });
                }
            }, {
                text: 'Batal',
                color: 'red',
                close: true
            }];

            let actionSheet = app.actions.create({
                buttons: buttons
            }).open();
      
        },
        loadMore() {
            const self = this;

            if (!self.allowInfinite) return;
            self.allowInfinite = false;

            setTimeout(()=>{
                if(self.pagination.has_next){
                    self.getInfos(self.pagination.page + 1, true);
                    self.allowInfinite = true;                 
                }else{
                    self.showPreloader = false;
                }
            }, 1000);
        },
        handleInfoCategory(category){
			const self = this;
            const app = self.$f7;
            
            self.infoLoading = true;
            
            if(category == 'semua'){
                self.currentCategory = 'Semua';
                self.$store.dispatch('info/resetInfos', {
                    section: 'page'
                }).then(()=>{
                    if(self.currentLocation != null){
                        self.infoLoading = true;
                        self.getInfos(1, false);
                    }else{
                        self.infoLoading = false;
                        self.showPreloader = false;
                    }
                });
            }else{
                self.currentCategory = 'Info Saya';
                self.$store.dispatch('info/resetInfos', {
                    section: 'page'
                }).then(()=>{
                    self.infoLoading = true;
                    self.getInfos(1, false);
                });
            }            
		}
    }
}
</script>
